Loading...
Searching...
No Matches
casacore::LCEllipsoid Class Reference
lattices package (libcasa_lattices) » LRegions_module

More...

`#include <LCEllipsoid.h>`

## Public Member Functions

| LCEllipsoid ()
| LCEllipsoid (const IPosition &center, Float radius, const IPosition &latticeShape)
| Construct an N-dimensional sphere with the given center and radius (in pixels).
| LCEllipsoid (const Vector< Float > &center, Float radius, const IPosition &latticeShape)
| Construct an N-dimensional sphere with the given center and radius (in pixels).
| LCEllipsoid (const Vector< Double > &center, Double radius, const IPosition &latticeShape)
| LCEllipsoid (const Vector< Float > &center, const Vector< Float > &radii, const IPosition &latticeShape)
| Construct an N-dimensional ellipsoid with the given center and radii (in pixels).
| LCEllipsoid (const Vector< Double > &center, const Vector< Double > &radii, const IPosition &latticeShape)
| LCEllipsoid (const Float xcenter, const Float ycenter, const Float majorAxis, const Float minorAxis, const Float theta, const IPosition &latticeShape)
| Construct a two dimensional ellipse with theta being the angle from the x-axis to the major axis of the ellipse in radians.
| LCEllipsoid (const LCEllipsoid &other)
| Copy constructor (reference semantics).
virtual | ~LCEllipsoid ()
LCEllipsoid & | operator= (const LCEllipsoid &other)
| Assignment (copy semantics).
virtual Bool | operator== (const LCRegion &other) const
| Comparison.
virtual LCRegion * | cloneRegion () const
| Make a copy of the derived object.
const Vector< Float > & | center () const
| Get the center.
const Vector< Float > & | radii () const
| Get the radii.
const Float & | theta () const
| Get the angle of the major axis of the ellipse relative to the x-axis 2-D only, throws exception if ellipse is not 2-D.
virtual String | type () const
| Get the region type.
virtual TableRecord | toRecord (const String &tableName) const
| Convert the (derived) object to a record.
Public Member Functions inherited from casacore::LCRegionFixed
| LCRegionFixed ()
| LCRegionFixed (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegionFixed (const LCRegionFixed &other)
| Copy constructor (copy semantics).
virtual | ~LCRegionFixed ()
| Destructor.
const ArrayLattice< Bool > & | getMask () const
| Return the mask.
Public Member Functions inherited from casacore::LCRegionSingle
| LCRegionSingle ()
| LCRegionSingle (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegionSingle (const LCRegionSingle &other)
| Copy constructor (copy semantics).
virtual | ~LCRegionSingle ()
virtual Bool | hasMask () const
| Does the region have a mask?
const Array< Bool > | maskArray () const
| Get the mask (as an array).
Bool | masksEqual (const LCRegion &other) const
| Is the mask of this region the same as the mask of the other.
virtual void | set (const Bool &value)
| The following "put" functions are described in detail in class Lattice.
virtual void | apply (Bool(*function)(Bool))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (Bool(*function)(const Bool &))
virtual void | apply (const Functional< Bool, Bool > &function)
virtual void | putAt (const Bool &value, const IPosition &where)
| Put the value of a single element.
virtual void | copyData (const Lattice< Bool > &from)
| Copy the data from the given lattice to this one.
Public Member Functions inherited from casacore::LCRegion
| LCRegion ()
| LCRegion (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegion (const LCRegion &other)
| Copy constructor (copy semantics).
virtual | ~LCRegion ()
Bool | operator!= (const LCRegion &other) const
| Non-equality.
virtual Lattice< Bool > * | clone () const
| Make a copy of the derived object.
virtual void | handleDelete ()
| Handle deletion of the region by deleting possible tables.
virtual void | handleRename (const String &newName, Bool overwrite)
| Handle renaming the region by renaming possible tables.
const String & | comment () const
| Get or set the comment.
void | setComment (const String &comment)
LCRegion * | translate (const IPosition &translateVector) const
| Construct another LCRegion (for e.g.
LCRegion * | translate (const IPosition &translateVector, const IPosition &newLatticeShape) const
LCRegion * | translate (const Vector< Float > &translateVector) const
LCRegion * | translate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
const IPosition & | latticeShape () const
| Give the full lattice shape.
const Slicer & | boundingBox () const
| Give the bounding box.
Slicer | expand (const Slicer &slicer) const
| Expand a slicer or position in the region to the full lattice.
IPosition | expand (const IPosition &index) const
virtual uInt | ndim () const
| Return the dimensionality of the region.
virtual IPosition | shape () const
| Return the shape of the region (i.e.
virtual Bool | isWritable () const
| Usually the lattice (i.e.
Public Member Functions inherited from casacore::Lattice< Bool >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
Bool | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual Bool | getAt (const IPosition &where) const
Bool | get (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | put (const Array< Bool > &sourceBuffer)
void | operator+= (const Lattice< Bool > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< Bool > &other)
void | operator*= (const Lattice< Bool > &other)
void | operator/= (const Lattice< Bool > &other)
virtual void | copyDataTo (Lattice< Bool > &to) const
| Copy the data from this lattice to the given lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the advised maximum number of pixels to include in the cursor of an iterator.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Static Public Member Functions

static String | className ()
| Get the class name (to store in the record).
static LCEllipsoid * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.
Static Public Member Functions inherited from casacore::LCRegion
static LCRegion * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.

## Protected Member Functions

virtual LCRegion * | doTranslate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
| Construct another LCBox (for e.g.
Protected Member Functions inherited from casacore::LCRegionFixed
LCRegionFixed & | operator= (const LCRegionFixed &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setMask (const Array< Bool > &mask)
| Set the mask.
Protected Member Functions inherited from casacore::LCRegionSingle
LCRegionSingle & | operator= (const LCRegionSingle &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setMaskPtr (Lattice< Bool > &mask)
| Set the pointer to the mask in the derived class.
virtual Bool | doGetSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual getting of the mask.
virtual void | doPutSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Do the actual putting of the mask.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Get the best cursor shape.
virtual LatticeIterInterface< Bool > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| Make an iterator.
Protected Member Functions inherited from casacore::LCRegion
LCRegion & | operator= (const LCRegion &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setBoundingBox (const Slicer &boundingBox)
| Sometimes it is inconvenient for a derived class to set the bounding box in the constructor.
void | setShapeAndBoundingBox (const IPosition &latticeShape, const Slicer &boundingBox)
void | defineRecordFields (RecordInterface &record, const String &className) const
| Define the type and class name in the record.
Protected Member Functions inherited from casacore::Lattice< Bool >
void | handleMathTo (Lattice< Bool > &, int) const
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< Bool > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
Lattice< Bool > & | operator= (const Lattice< Bool > &)
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Member Functions

void | fillCenter (const IPosition &center)
| Fill the itsCenter vector from an IPosition.
Slicer | makeBox (const Vector< Float > &radii, const IPosition &latticeShape)
| Make the bounding box from center, radii, and shape.
void | defineMask ()
| Define the mask to indicate which elements are inside the ellipsoid.
void | _defineMask2D ()
| for 2-D ellipse with non-zero theta.
void | _doOutside ()
| set the mask in the case the center lies outside the lattice

## Private Attributes

Vector< Float > | itsCenter
Vector< Float > | itsRadii
Vector< Float > | _epsilon
| small offset to guard against roundoff error
Float | _theta
| for 2-D case only
Bool | _centerIsInside
| is center inside the lattice?

## Detailed Description

Define an N-dimensional ellipsoidal region of interest.

### Intended use:

Public interface

### Prerequisite

- LCRegion

### Synopsis

The LCEllipsoid class is a specialization of class LCRegion. It makes it possible to define an N-dimensional ellipsoidal region of interest, which includes the border. A separate constructor exists to define the special case of an N-dimensional sphere.
The center and the radii of the ellipsoid do not need to be pixel aligned. The center of the ellipsoid may be outside the lattice. The current implementation only supports ellipsoids with axes parallel to the lattice axes except in the case of a 2-D ellipse for which a constructor is provided for specifying the angle between the x-axis and major axis of the ellipse.

It can only be used for a lattice of any dimensionality as long as the dimensionality of the (hyper-)ellipsoid matches the dimensionality of the lattice.

### Example

### To Do

- Arguments to have ellipsoid axes not parallel to lattice axes for dimensions greater than 2. This is a nontrivial problem because of the complexity of the rotation matrices involved.

Definition at line 81 of file LCEllipsoid.h.

## Constructor & Destructor Documentation

## LCEllipsoid() [1/8]

casacore::LCEllipsoid::LCEllipsoid | ( |  | ) |

Referenced by fromRecord(), LCEllipsoid(), and operator=().

## LCEllipsoid() [2/8]

casacore::LCEllipsoid::LCEllipsoid | ( | const IPosition & | center,
|  | Float | radius,
|  | const IPosition & | latticeShape )

Construct an N-dimensional sphere with the given center and radius (in pixels).

The center is pixel-aligned.

References center(), and casacore::LCRegion::latticeShape().

## LCEllipsoid() [3/8]

casacore::LCEllipsoid::LCEllipsoid | ( | const Vector< Float > & | center,
|  | Float | radius,
|  | const IPosition & | latticeShape )

Construct an N-dimensional sphere with the given center and radius (in pixels).

The center does not need to be pixel-aligned.

References center(), and casacore::LCRegion::latticeShape().

## LCEllipsoid() [4/8]

casacore::LCEllipsoid::LCEllipsoid | ( | const Vector< Double > & | center,
|  | Double | radius,
|  | const IPosition & | latticeShape )

References center(), and casacore::LCRegion::latticeShape().

## LCEllipsoid() [5/8]

casacore::LCEllipsoid::LCEllipsoid | ( | const Vector< Float > & | center,
|  | const Vector< Float > & | radii,
|  | const IPosition & | latticeShape )

Construct an N-dimensional ellipsoid with the given center and radii (in pixels).

The center does not need to be pixel-aligned. (the radii are half the length of the axes of the ellipsoid).

References center(), casacore::LCRegion::latticeShape(), and radii().

## LCEllipsoid() [6/8]

casacore::LCEllipsoid::LCEllipsoid | ( | const Vector< Double > & | center,
|  | const Vector< Double > & | radii,
|  | const IPosition & | latticeShape )

References center(), casacore::LCRegion::latticeShape(), and radii().

## LCEllipsoid() [7/8]

casacore::LCEllipsoid::LCEllipsoid | ( | const Float | xcenter,
|  | const Float | ycenter,
|  | const Float | majorAxis,
|  | const Float | minorAxis,
|  | const Float | theta,
|  | const IPosition & | latticeShape )

Construct a two dimensional ellipse with theta being the angle from the x-axis to the major axis of the ellipse in radians.

References casacore::LCRegion::latticeShape(), and theta().

## LCEllipsoid() [8/8]

casacore::LCEllipsoid::LCEllipsoid | ( | const LCEllipsoid & | other | ) |

Copy constructor (reference semantics).

References LCEllipsoid().

## ~LCEllipsoid()

virtual casacore::LCEllipsoid::~LCEllipsoid | ( |  | ) |

virtual

## Member Function Documentation

## _defineMask2D()

void casacore::LCEllipsoid::_defineMask2D | ( |  | ) |

private

for 2-D ellipse with non-zero theta.

Works for both cases center inside or outside the lattice.

## _doOutside()

void casacore::LCEllipsoid::_doOutside | ( |  | ) |

private

set the mask in the case the center lies outside the lattice

## center()

const Vector< Float > & casacore::LCEllipsoid::center | ( |  | ) | const

inline

Get the center.

Definition at line 191 of file LCEllipsoid.h.

References itsCenter.

Referenced by fillCenter(), LCEllipsoid(), LCEllipsoid(), LCEllipsoid(), LCEllipsoid(), and LCEllipsoid().

## className()

String casacore::LCEllipsoid::className | ( |  | ) |

static

Get the class name (to store in the record).

## cloneRegion()

virtual LCRegion * casacore::LCEllipsoid::cloneRegion | ( |  | ) | const

virtual

Make a copy of the derived object.

Implements casacore::LCRegion.

## defineMask()

void casacore::LCEllipsoid::defineMask | ( |  | ) |

private

Define the mask to indicate which elements are inside the ellipsoid.

## doTranslate()

virtual LCRegion * casacore::LCEllipsoid::doTranslate | ( | const Vector< Float > & | translateVector,
|  | const IPosition & | newLatticeShape ) const

protected virtual

Construct another LCBox (for e.g.

another lattice) by moving this one. It recalculates the bounding box. A positive translation value indicates "to right".

Implements casacore::LCRegion.

## fillCenter()

void casacore::LCEllipsoid::fillCenter | ( | const IPosition & | center | ) |

private

Fill the itsCenter vector from an IPosition.

References center().

## fromRecord()

LCEllipsoid * casacore::LCEllipsoid::fromRecord | ( | const TableRecord & | ,
|  | const String & | tableName )

static

Convert correct object from a record.

References LCEllipsoid().

## makeBox()

Slicer casacore::LCEllipsoid::makeBox | ( | const Vector< Float > & | radii,
|  | const IPosition & | latticeShape )

private

Make the bounding box from center, radii, and shape.

References casacore::LCRegion::latticeShape(), and radii().

## operator=()

LCEllipsoid & casacore::LCEllipsoid::operator= | ( | const LCEllipsoid & | other | ) |

Assignment (copy semantics).

References LCEllipsoid().

## operator==()

virtual Bool casacore::LCEllipsoid::operator== | ( | const LCRegion & | other | ) | const

virtual

Comparison.

Reimplemented from casacore::LCRegionFixed.

## radii()

const Vector< Float > & casacore::LCEllipsoid::radii | ( |  | ) | const

inline

Get the radii.

Definition at line 195 of file LCEllipsoid.h.

References itsRadii.

Referenced by LCEllipsoid(), LCEllipsoid(), and makeBox().

## theta()

const Float & casacore::LCEllipsoid::theta | ( |  | ) | const

Get the angle of the major axis of the ellipse relative to the x-axis 2-D only, throws exception if ellipse is not 2-D.

Referenced by LCEllipsoid().

## toRecord()

virtual TableRecord casacore::LCEllipsoid::toRecord | ( | const String & | tableName | ) | const

virtual

Convert the (derived) object to a record.

Implements casacore::LCRegion.

## type()

virtual String casacore::LCEllipsoid::type | ( |  | ) | const

virtual

Get the region type.

Returns className()

Implements casacore::LCRegion.

## Member Data Documentation

## _centerIsInside

Bool casacore::LCEllipsoid::_centerIsInside

private

is center inside the lattice?

Definition at line 187 of file LCEllipsoid.h.

## _epsilon

Vector<Float> casacore::LCEllipsoid::_epsilon

private

small offset to guard against roundoff error

Definition at line 183 of file LCEllipsoid.h.

## _theta

Float casacore::LCEllipsoid::_theta

private

for 2-D case only

Definition at line 185 of file LCEllipsoid.h.

## itsCenter

Vector<Float> casacore::LCEllipsoid::itsCenter

private

Definition at line 180 of file LCEllipsoid.h.

Referenced by center().

## itsRadii

Vector<Float> casacore::LCEllipsoid::itsRadii

private

Definition at line 181 of file LCEllipsoid.h.

Referenced by radii().

The documentation for this class was generated from the following file:

- lattices/LRegions/LCEllipsoid.h